//+------------------------------------------------------------------+
//|                                                          777.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  White
#property  indicator_width1  1
#property indicator_color2 Magenta
#property indicator_color3 Orange

//---- 
//----   MACD1

extern string IIIIIIIIIIIIIIIIIIIIIIIIIIII=">>> OsMA >>>>>>>>>>>>>>>";
extern int MA1=9;
extern int MA2=21;
extern int MA3=5;
extern string IIIIIIIIIIIIIIIIIIIIIIIIIII=">>> ZL_MACD >>>>>>>>>>>>>>>";
extern int FastEMA=9;
extern int SlowEMA=55;
extern int SignalEMA=1;

//----
double OsMA_Buffer[];
double MACDBuffer[];
double SignalBuffer[];
double FastEMABuffer[];
double SlowEMABuffer[];
double SignalEMABuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
    
//----OsMA
  SetIndexStyle(0, DRAW_HISTOGRAM);
    SetIndexBuffer(0,OsMA_Buffer);
//----ZL_MACD
IndicatorBuffers(5);
   SetIndexBuffer(1,MACDBuffer);
   SetIndexBuffer(2,SignalBuffer);
   SetIndexBuffer(3,FastEMABuffer);
   SetIndexBuffer(4,SlowEMABuffer);
   SetIndexBuffer(5,SignalEMABuffer);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(1,SlowEMA);
   SetIndexDrawBegin(2,SlowEMA);
//----
   IndicatorShortName("Diver3");
        SetIndexLabel(0,"OsMA");
        SetIndexLabel(1,"ZL_MACD");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   
//----      ,  
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;
   
//----   ZL_MACD
   double EMA,ZeroLagEMAp,ZeroLagEMAq;
   
//---- OsMA 
   for(int i=0; i<limit; i++){
      OsMA_Buffer[i]=iOsMA(NULL,0,MA1,MA2,MA3,PRICE_CLOSE,i);
      }
//----ZL_MACD
   if(counted_bars<0) return(-1);
   for(i=0; i<limit; i++)
      {
         FastEMABuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);
         SlowEMABuffer[i]=iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
      }
   for(i=0; i<limit; i++)
      {
         EMA=iMAOnArray(FastEMABuffer,Bars,FastEMA,0,MODE_EMA,i);
         ZeroLagEMAp=FastEMABuffer[i]+FastEMABuffer[i]-EMA;
         EMA=iMAOnArray(SlowEMABuffer,Bars,SlowEMA,0,MODE_EMA,i);
         ZeroLagEMAq=SlowEMABuffer[i]+SlowEMABuffer[i]-EMA;
         MACDBuffer[i]=ZeroLagEMAp - ZeroLagEMAq;
      }
  
   
      
//----
   return(0);
  }
//+------------------------------------------------------------------+